LeetCode 779 - K-th Symbol in Grammar


http://bookshadow.com/weblog/2018/02/04/leetcode-k-th-symbol-in-grammar/
On the first row, we write a 0. Now in every subsequent row, we look at the previous row and replace each occurrence of 0 with 01, and each occurrence of 1 with 10.
Given row N and index K, return the K-th indexed symbol in row N. (The values of K are 1-indexed.) (1 indexed).
Examples:
Input: N = 1, K = 1
Output: 0

Input: N = 2, K = 1
Output: 0

Input: N = 2, K = 2
Output: 1

Input: N = 4, K = 5
Output: 1

Explanation:
row 1: 0
row 2: 01
row 3: 0110
row 4: 01101001
X. https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113710/Python-simple-solution-to-understand-with-explanations
观察一下规律就知道,下一行是左边保留上一行,右边是上一行取反
用递归,已知N == 1的时候返回0,为了知道第N行第K个数字的值,只要知道它在第N-1行的第(K+1)/2个数字对应的值即可,因为0对应01,1对应10,那么如果K是奇数只需和原数字相同即可,如果K是偶数只需对原对应数字取反即可
We don't need to actually generate the strings "0110..." (would be TLE error anyway)
We see that, for any level N, the first half of the string is the same as the string in N-1, the next half is just complement of it. The total number of items in level N is 2^N. The half mark of the string is marked by [2^(N-1)]-th item. So, for any level N:
  • if K is in the first half, it is same as the Kth element in level N-1
  • if K is in the second half, it is the complement of the number in [K-2^(N-1)]-th position in level N-1
So, we run the recursion until the base condition (N=1)

https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113697/My-3-lines-C++-recursive-solution
The whole structure can be viewed a binary tree, when a node is 0, their two children nodes are 0 and 1, similarly, when a node is 1, two children nodes are 1 and 0. We can know whether the position of K is a left node or a right node by dividing 2. If K is even, current node is right child, and its parent is the (K/2)th node in previous row; else if K is odd, current node is left child and its parent is the ((K+1)/2)th node in previous row.
The value of current node depends on its parent node, without knowing its parent node value, we still cannot determine current node value. That's why we need recursion, we keep going previous row to find the parent node until reach the first row. Then all the parent node value will be determined after the recursion function returns.
public int kthGrammar(int N, int K) {
    if (N == 1) return 0; //first line only has one number 0
    if (K % 2 == 0) return kthGrammar(N - 1, K / 2) == 0 ? 1 : 0; //If K is even, find the appended number at correct position of previous row
    return kthGrammar(N - 1, (K + 1) / 2); //If K is odd, just find the correct position from previous row
}
X.
Note that N is redundant in this problem.
int kthGrammar(int, int K) {
    return K == 1 ? 0 : (~K & 1) ^ kthGrammar(0, (K + 1) / 2);
}
https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113721/C++-with-explanation-three-solutions-O(n)-O(logn)-and-O(loglogn)
The structure is like a full tree.
0 ==> 01; 1 ==> 10; so if only if K%2 == 0, result(K) == result(K/2);
The key is whether the set bits of (K-1) is odd or even
O(logn) 3ms
    int kthGrammar(int N, int K) {
        K--;
        int cnt = 0;
        while (K) {
            cnt += K&1;
            K >>= 1;
        }
        return cnt%2;
    }
If we only care about the set bits are odd or even, there is an O(loglogn) solution.
Although O(loglogn) may be meaningless here, because logn is at most 32. Let's assume K is m bits long.
    int kthGrammar(int N, int K) {
       K--;
       int m = 32;
       while (m > 1) {
          m = (m + 1) >> 1;
          K = K ^ (K >> m);
          K &= (1 << m) - 1;
       }
       return K & 1;
    }


X.
https://blog.csdn.net/huanghanqian/article/details/79254001
sequence中的序列正好是题目中的序列。
https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113705/JAVA-one-line
public int kthGrammar(int N, int K) {
    return Integer.bitCount(K-1) & 1;
}
Updates(all index discussed below are 0-based)
Observation 1N does not matter as long as "K will be an integer in the range [1, 2^(N-1)]". We can ignore N.
Observation 2: let f(k) be the value of kth position (0-based), then:
f(2 * k) = 0 {if f(k) = 0} or, 1 {if f(k) = 1} => f(2 * k) = f(k) xor 0
f(2 * k + 1) = 0 {if f(k) = 1} or 1 {if f(k) = 0} => f(2 * k + 1) = f(k) xor 1
Obervation 3: if binary string of k is used, let k = 1001010, then we have:
f(1001010) = f(100101) ^ 0 = f(10010) ^ 1 ^ 0 = f(1001) ^ 0 ^ 1 ^ 0 = ... = f(0) ^ 1 ^ 0 ^ 0 ^1 ^ 0 ^ 1 ^ 0 = 1 ^ 0 ^ 0 ^1 ^ 0 ^ 1 ^ 0
So, the result is the xor operation on all bits of k. Since 0 does not change xor result, we can ignore all 0s.
f(1001010) = 1 ^ 1 ^ 1 = (1^1) ^ 1 = 0 ^ 1 = 1
f(11110011) = 1 ^ 1^ 1 ^ 1 ^ 1 ^1 = (1 ^ 1) ^ (1 ^ 1) ^ (1 ^1) = 0
Now, it's easy to tell f(k) = 0 if k has even number of 1s in binary representation, and f(k) = 1 when k has odd number of 1s
     The L_th number in row N-1 will generate 2 numbers in row N at position 2L and 2L+1
     Note the pattern given in the problem 0 -> 01, 1->10.
     This means the first digit will always stay the same, and the second digit will flip between 0 and 1

     Now looking backward, our K could be 2L or 2L+1
     If K is 2L, we know it'll take the same value as L in row N-1.
     If K is 2L+1, it'll take the flipped value
     keep doing this x times until we hit the initial value of 0 in row 1.
     During this x times of recursion, say there are y times where K is odd. Those are the times when the value flipped between 0 and 1
     so the end result is the initial value 0, flipped y times
    
     Now going from K (2L or 2L+1) to L, is really just right shifting K by 1 bit
     Before you shift, check if the least significant bit of K is 1, if so, record one occurrence of an odd number
     essentially this is the same as counting the number of 1's in K's binary representation
https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113736/PythonJavaC++-Easy-1-line-Solution-with-detailed-explanation
First, you can easily find that prefix of every row is exactly the same.
It not difficult to understand.
Beacause every 2 * L fisrt letters are generated by the same L fist letters.
Then, we know that every row is the start part of the same long sequence.
Moreover K is guaranteed to be an integer in the range[1, 2 ^ (N - 1)].
So result depends only on value K
Suppose 2 ^ L < K <= 2 ^ (L + 1).
2 ^ (L - 1) is the biggest 2's power smaller than K.
Kth number is generated from K - 2 ^ (L - 1)
Kth number is also different from K - 2 ^ (L - 1)
So we toggle K to K - 2 ^ L by subtracting 2 ^ L
We repeat the process until we toggle K to 1, which mean we need to substract K - 1 in total.
What we should do is transfer K - 1 in binary so that we can easily find how many times we need to toggle.
For example K = 8
we need to substract K - 1 = 7 = 111 in binary.
So we need to substract 10010 and 1, which are 4, 2, 1 in decimal.
We toggle K from 8 to 42 and finally 1.
For example K = 9
we need to substract K - 1 = 8 = 1000 in binary.
So we need to substract 1000, which is 8 in decimal.
We toggle K from 9 to 1 directly.
Conclusion
we turn this problem to just count 1bits.
We can observe that the answer depend on whether the number of 1 bits in binary K-1 is odd or even.
Now you may have many ways to solve this problem.
In Python, I transfer K to binary.
In Java, bitCount is ready for use.
In C++, I use the trick K & (K - 1) to drops the lowest bit.

X.
https://leetcode.com/problems/k-th-symbol-in-grammar/discuss/113721/C++-with-explanation-three-solutions-O(n)-O(logn)-and-O(loglogn)
    int kthGrammar(int N, int K) {
        string s = "0";
        for (int i = 1; i < N; ++i) {
            string t;
            for (char c : s) {
                if (c == '0')
                   t += "01";
                else
                   t += "10";
            }
            swap(s, t);
        }
        return s[K-1]-'0';
    }


// also use too much memory
// TLE, what we don't need to do:
// We don't have to generate the strings for each row
public int kthGrammar(int n, int k) {
if (n < 0 || k < 0) {
return -1;
}
if (k > Math.pow(2, n - 1)) {
return -1;
}
List<Integer> preRow = new ArrayList<>();
for (int i = 0; i < n; i++) {
preRow = nthRowGrammar(preRow);
// System.out.println(preRow);
}

return preRow.get(k - 1);
}

private static Map<List<Integer>, List<Integer>> expandCache = new HashMap<>(); // not good use list as key of map

public List<Integer> nthRowGrammar(List<Integer> preRow) {

if (expandCache.containsKey(preRow)) {
return new ArrayList<>(expandCache.get(preRow));
}
List<Integer> result = new ArrayList<>();
if (preRow.isEmpty()) {
result.add(0);
expandCache.put(preRow, result);
return result;
// return Arrays.asList(0);// Collections.unmodifiableList(Arrays.asList(0));
}

if (preRow.size() == 1) {
int value = preRow.get(0);
if (value == 0) {
result.add(0);
result.add(1);
expandCache.put(preRow, result);
return result;
} else {
result.add(1);
result.add(0);
expandCache.put(preRow, result);
return result;
}
}

result.addAll(nthRowGrammar(preRow.subList(0, preRow.size() / 2)));
result.addAll(nthRowGrammar(preRow.subList(preRow.size() / 2, preRow.size()))); // not preRow.size() -1 [}
expandCache.put(preRow, result);

return result;
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts